//+------------------------------------------------------------------+
//|																geSinForm.mq4		|
//|                      Copyright  2007, ver 1.0							|
//|                      Forte928           									|
//+------------------------------------------------------------------+
#property copyright "Forte928"
#property link      ""
#define		IndicatorName "geSinForm"
#define	Pi 3.14159265358979323846

//----
/*#import "#_lib_FFT.ex4"
void FastFourierTransform(double& aySignal[], int nn, bool InverseFFT);
void RealFastFourierTransform(double& aySignal[], int iSizeValue, bool InverseFFT);
void FastSineTransform(double& aySignal[], int iSizeValue, bool InverseFST);
void FastCosineTransform(double& aySignal[], int iSizeValue, bool InverseFCT);
#import
*/
//#property indicator_chart_window
#property indicator_separate_window

//#property indicator_level1 1.4
//#property indicator_level2 1.2
//#property indicator_level3 1
//#property indicator_level4 0.8
//#property indicator_level5 0.6
//#property indicator_level6 -50
//#property indicator_minimum -1.5
//#property indicator_maximum 1.5

#property indicator_buffers 8
#property indicator_color1 OrangeRed//Goldenrod//LightSkyBlue
#property indicator_color2 Lime
#property indicator_color3 RoyalBlue//PaleGreen
#property indicator_color4 Goldenrod//PaleGreen
#property indicator_color5 Aqua
#property indicator_color6 Violet
#property indicator_color7 Khaki//Coral
#property indicator_color8 WhiteSmoke

extern int		FastPrd	=377;
extern int		SlowPrd	=34;
extern int		WaveCount=5;
extern int		WinSize	=1;
extern int	 	FFT_Size		= 2048;
extern int		Harmonic		= 35;
extern int		Shift		=0;
extern double	Weight	=0.1;
extern int	 	Counter	=2000;

//double  FreqTOL  =0.0001;//Tolerance of frequency calculation for Method 1

double	FxView1[];
double	FxView2[];
double	FxView3[];
double	FxView4[];
double	FxView5[];
double	FxView6[];
double	FxView7[];
double	FxView8[];
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Work Variables ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int Ix;
int Sx;


datetime	TimeCalc;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Work Variables ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
double	ActiveLower[];			//     
double	ActiveHigher[];		//    
double	ActiveCloser[];		//    close
double	ActiveOpener[];		//    open

int		IndexBuf1[];
int		IndexBuf2[];
int		IndexBuf3[];
int		IndexBuf4[];

double	TimeBuf1[];
double	TimeBuf2[];
double	TimeBuf3[];
double	TimeBuf4[];
double	TimeBuf5[];
double	TimeBuf6[];
double	TimeBuf7[];
double	TimeBuf8[];
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Initialization program Buffers ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	InitBufferam(int iBufferSize){
	ArrayResize(ActiveLower,iBufferSize);
	ArrayResize(ActiveHigher,iBufferSize);
	ArrayResize(ActiveCloser,iBufferSize);
	ArrayResize(ActiveOpener,iBufferSize);

	ArrayResize(IndexBuf1,iBufferSize);
	ArrayResize(IndexBuf2,iBufferSize);
	ArrayResize(IndexBuf3,iBufferSize);
	ArrayResize(IndexBuf4,iBufferSize);

	ArrayResize(TimeBuf1,iBufferSize);
	ArrayResize(TimeBuf2,iBufferSize);
	ArrayResize(TimeBuf3,iBufferSize);
	ArrayResize(TimeBuf4,iBufferSize);
	ArrayResize(TimeBuf5,iBufferSize);
	ArrayResize(TimeBuf6,iBufferSize);
	ArrayResize(TimeBuf7,iBufferSize);
	ArrayResize(TimeBuf8,iBufferSize);
	return;
}
void	EmptyBufferam(){
	ArrayInitialize(ActiveLower,EMPTY_VALUE);
	ArrayInitialize(ActiveHigher,EMPTY_VALUE);
	ArrayInitialize(ActiveCloser,EMPTY_VALUE);
	ArrayInitialize(ActiveOpener,EMPTY_VALUE);

	ArrayInitialize(IndexBuf1,EMPTY_VALUE);
	ArrayInitialize(IndexBuf2,EMPTY_VALUE);
	ArrayInitialize(IndexBuf3,EMPTY_VALUE);
	ArrayInitialize(IndexBuf4,EMPTY_VALUE);

	ArrayInitialize(TimeBuf1,EMPTY_VALUE);
	ArrayInitialize(TimeBuf2,EMPTY_VALUE);
	ArrayInitialize(TimeBuf3,EMPTY_VALUE);
	ArrayInitialize(TimeBuf4,EMPTY_VALUE);
	ArrayInitialize(TimeBuf5,EMPTY_VALUE);
	ArrayInitialize(TimeBuf6,EMPTY_VALUE);
	ArrayInitialize(TimeBuf7,EMPTY_VALUE);
	ArrayInitialize(TimeBuf8,EMPTY_VALUE);
// -->
	InitChart(FxView1);														// -->
	InitChart(FxView2);														// -->
	InitChart(FxView3);														// -->
	InitChart(FxView4);														// -->
	InitChart(FxView5);														// -->
	InitChart(FxView6);														// -->
	InitChart(FxView7);														// -->
	InitChart(FxView8);														// -->
	return;
}
void	DoneBufferam(){
	ArrayResize(ActiveLower,0);
	ArrayResize(ActiveHigher,0);
	ArrayResize(ActiveCloser,0);
	ArrayResize(ActiveOpener,0);

	ArrayResize(IndexBuf1,0);
	ArrayResize(IndexBuf2,0);
	ArrayResize(IndexBuf3,0);
	ArrayResize(IndexBuf4,0);

	ArrayResize(TimeBuf1,0);
	ArrayResize(TimeBuf2,0);
	ArrayResize(TimeBuf3,0);
	ArrayResize(TimeBuf4,0);
	ArrayResize(TimeBuf5,0);
	ArrayResize(TimeBuf6,0);
	ArrayResize(TimeBuf7,0);
	ArrayResize(TimeBuf8,0);
	//---------------------------------
	return;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Program Constants ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int		MaxPeriod=0;
int		CalcCount=0;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//#include <Control\ge_VKKeyCode.mq4>
//#include <Memory\ge_Values.mq4>
//#include <Memory\ge_Temp.mq4>
//#include <General\ge_Oscilator.mq4>
//#include <General\ge_Include.mq4>
//#include <Filter\ge_Extrapolator.mq4>
//#include <General\ge_TicketCtrlv3.mq4>													// -->
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator initialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int init()
  {
//---- initialization program values  --------------------------------
	MaxPeriod=MathMax(FastPrd,MathMax(SlowPrd,MathMax(SlowPrd,SlowPrd)));
	//InitTempBuf(MaxCounter(Counter,MaxPeriod),4);
	//InitBufferam(MaxCounter(Counter,MaxPeriod));
	InitBufferam(Counter);
	CalcCount=InitCounter(Counter,MaxPeriod);
	TimeCalc=0;									// Ticket  ,     
	SetIndexArrow(4,217);
	SetIndexArrow(5,218);

//---- initialization indicators -------------------------------------
	SetupChartLine(0,FxView1,0,1,"Fast");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(1,FxView2,0,1,"Slow");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(2,FxView3,0,1,"Long");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(3,FxView4,0,1,"Multi");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(4,FxView5,0,1,"TanLine");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(5,FxView6,0,1,"FFT_MA");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(6,FxView7,2,1,"Upper");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(7,FxView8,2,1,"Downer");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
   IndicatorShortName(IndicatorName+"("+FastPrd+","+SlowPrd+","+SlowPrd+"("+"))");
  	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
	
	TicketGo(0);
	//InitTicket(StringSubstr(IndicatorName,2,StringLen(IndicatorName)-2));					// -->

//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator deinitialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int deinit()
  {
//----
	DoneBufferam();	
	//DoneTempBuf();
	//DoneTicket();																	// -->
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Start defination ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int start()
{
	//if (StartTicket()==false)											// -->
	{																					// -->
		//if (!TicketGo(1)) return(0);
		if (!StartCounter(IndicatorName,Counter,CalcCount,MaxPeriod)) return(-1);
	}																					// -->
//	else {																			// -->
		//if (cwCalculated==true) return(0);									// -->
//	}																					// -->
//------------------------------------------------------------------------------------
//-----------  -       -------------
	int CalcBuffer=iBarShift(NULL,0,TimeCalc,false)+1;
	if (CalcBuffer>=CalcCount) CalcBuffer=CalcCount;
	//int ShiftCalc=CalcOut-CountCalc;
	for (Sx=CalcCount-1;Sx>CalcBuffer;Sx--) 
	{
		//TimeBuf1[Sx]=TimeBuf1[Sx-CountCalc+1];
	}
	EmptyBufferam();
//+-------------------------- Begin Cycle ---------------------------------------------------+\\

	//ReadValueTicket(Shift);											// -->

	double RxMax=10;
	for (int Rx=0;Rx<CalcCount;Rx++){
		TimeBuf1[Rx]=Close[0];//MathSin(2*Pi*MathMod(Rx,FastPrd)/(FastPrd));
		TimeBuf2[Rx]=0;//MathSin(2*Pi*MathMod(Rx,FastPrd)/(FastPrd));
		TimeBuf3[Rx]=0;//MathSin(2*Pi*MathMod(Rx,FastPrd)/(FastPrd));
		TimeBuf4[Rx]=Close[0];//MathSin(2*Pi*MathMod(Rx,FastPrd)/(FastPrd));
		double RxPeriod=FastPrd;
		double RxHigh=RxMax;
		for (Sx=0;Sx<1;Sx++){
//			TimeBuf1[Rx]=TimeBuf1[Rx]+MathSin(2*Pi*MathMod(Rx,(RxPeriod))/(RxPeriod));
			RxPeriod=RxPeriod*1.618;
		}
		RxPeriod=FastPrd;
		RxHigh=RxMax;
		for (Sx=0;Sx<2;Sx++){
			if (RxPeriod>1) TimeBuf2[Rx]=TimeBuf2[Rx]+MathSin(2*Pi*MathMod(Rx,(RxPeriod))/(RxPeriod));
			RxPeriod=RxPeriod/(1.618*1.618*1.618);
		}
		RxPeriod=FastPrd;
		RxHigh=RxMax;
		for (Sx=0;Sx<5;Sx++){
//			TimeBuf3[Rx]=TimeBuf3[Rx]+MathSin(2*Pi*MathMod(Rx,(RxPeriod))/(RxPeriod));
			RxPeriod=RxPeriod*1.618;
		}
		RxPeriod=FastPrd;
		RxHigh=RxMax;
		for (Sx=0;Sx<WaveCount;Sx++){
			if (RxPeriod>1) TimeBuf4[Rx]=TimeBuf4[Rx]+MathPow(2,WaveCount-Sx)*Point*5*MathSin(2*Pi*MathMod(Rx,(RxPeriod))/(RxPeriod));
			RxPeriod=RxPeriod/(1.618*1.618*1.618);
			RxMax=RxMax/2;
		}
	}
//	ArrayCopy(FxView1,TimeBuf1,Shift,0,CalcCount);
//	ArrayCopy(FxView2,TimeBuf2,Shift,0,CalcCount);
//	ArrayCopy(FxView3,TimeBuf2,Shift,0,CalcCount);
	ArrayCopy(FxView2,TimeBuf4,Shift,0,CalcCount);
/*
	FFTFilter(TimeBuf4,TimeBuf4,TimeBuf1,Harmonic,FFT_Size);
	HPFilter(TimeBuf1,TimeBuf2,5,FFT_Size);
	FractalOnArray(TimeBuf2,TimeBuf2,ayITemp1,ayITemp2,2,2,5,FFT_Size);

	ArrayCopy(FxView3,TimeBuf1,Shift,0,FFT_Size);
	ArrayCopy(FxView4,TimeBuf2,Shift,0,FFT_Size);
	ArrayCopy(FxView7,ayITemp1,Shift,0,FFT_Size);
	ArrayCopy(FxView8,ayITemp2,Shift,0,FFT_Size);

	return;
	CopySeries(ActiveCloser,Period(),MODE_CLOSE,Shift);
	//HMA_LWMAOnArray(ActiveCloser,TimeBuf2,7,CalcCount);
	
	for (Ix=0;Ix<CalcCount;Ix++){
		TimeBuf1[Ix]=0;
		for (Sx=0;Sx<WaveCount;Sx++){
			TimeBuf1[Ix]=TimeBuf1[Ix]+ActiveCloser[Ix]*MathSin(Pi*(Ix+1)/((FastPrd+1)*0.618*(Sx+1)));
		}
	}
	//  ..
	for (Ix=CalcCount-1;Ix>=0;Ix--){
		TimeBuf2[Ix]=TimeBuf1[Ix]-TimeBuf1[Ix+WinSize];
		TimeBuf3[Ix]=TimeBuf1[Ix]-TimeBuf1[Ix+WinSize*2];
		TimeBuf4[Ix]=TimeBuf1[Ix]-TimeBuf1[Ix+WinSize*3];
		TimeBuf5[Ix]=TimeBuf1[Ix]-TimeBuf1[Ix+WinSize*4];
	}
	//HMA_LWMAOnArray(TimeBuf1,TimeBuf2,8,CalcCount);
	//  
	TimeBuf6[0]=0;
	for (Ix=1;Ix<CalcCount;Ix++){
		TimeBuf2[Ix]=TimeBuf1[Ix]-TimeBuf1[Ix+WinSize];
		TimeBuf3[Ix]=TimeBuf1[Ix]-TimeBuf1[Ix+WinSize*2];
		TimeBuf4[Ix]=TimeBuf1[Ix]-TimeBuf1[Ix+WinSize*3];
		TimeBuf5[Ix]=TimeBuf1[Ix]-TimeBuf1[Ix+WinSize*4];
	}


	ArrayCopy(FxView1,TimeBuf1,Shift,0,CalcCount);
	ArrayCopy(FxView2,TimeBuf2,Shift,0,CalcCount);
	ArrayCopy(FxView3,TimeBuf3,Shift,0,CalcCount);
	ArrayCopy(FxView4,TimeBuf4,Shift,0,CalcCount);
	ArrayCopy(FxView5,TimeBuf5,Shift,0,CalcCount);
	
	TimeCalc=Time[0];

	SetIndexDrawBegin(0,CalcCount);
	SetIndexDrawBegin(1,CalcCount);
	SetIndexDrawBegin(2,CalcCount);
	SetIndexDrawBegin(3,CalcCount);
	SetIndexDrawBegin(4,CalcCount);
*/
	//CalculateFinishedTicket();													// -->
//----
   return(0);
}
//--------------------------------- LagMAArrayShiftToCalc -----------------------------------
/*void SumRange(double Source[],double& Result[],int iWinSize,int iPeriod,int iCount)
{
	double aySimple[];
	ArrayResize(aySimple,iPeriod);
	ArrayInitialize(aySimple,0.0);
	double	SMAValue=0;
	int 		SMAIndex=0;
	for (int Kx=iCount-WinSize-1;Kx>=0;Kx--)
	{
		SMAValue=SMAValue-aySimple[SMAIndex];
		aySimple[SMAIndex]=(Source[Kx]);
		SMAValue=SMAValue+aySimple[SMAIndex];
		SMAIndex=MathCyclePrext(SMAIndex,1,iPeriod-1,0);
		Result[Kx]=(SMAValue/iPeriod);
	}
	return;
}
*///~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*void FFTFilter(double aySource[],double ayBases[],double& ayResult[],double iHarmonic,int iFFTSize)
{
	ArrayInitialize(ayResult,0.0);
	for (int Rx=iFFTSize-1;Rx>=0;Rx--) {
//		ayResult[Rx]=(aySource[Rx]-ayBases[Rx])/Point;
		ayResult[Rx]=aySource[Rx];
	}
	
	double WaveStep=1.618*1.618*1.618;
	FastCosineTransform(ayResult, iFFTSize, false);
	for (int Fx=iFFTSize-1;Fx>=0;Fx--) {
		if (Fx>iHarmonic) ayResult[Fx]=0.0;
		//if (Fx<iHarmonic) iHarmonic=MathFloor(iHarmonic/WaveStep);
	}
	FastCosineTransform(ayResult, iFFTSize, true);
	for (Rx=iFFTSize-1;Rx>=0;Rx--) {
//		ayResult[Rx]=ayResult[Rx]*Point+ayBases[Rx];
	}
	return;
}
*///~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 Style active Line																~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void SetupChartLine(int Index,double& ViewAy[],int Style,int Width,string Label)
{
	switch(Style)
	{
		case 0 : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
		case 1 : SetIndexStyle(Index,DRAW_HISTOGRAM,STYLE_SOLID,Width);break;
		case 2 : SetIndexStyle(Index,DRAW_ARROW,STYLE_SOLID,Width);break;
		case 3 : SetIndexStyle(Index,DRAW_ZIGZAG,STYLE_SOLID,Width);break;
		default : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
	}
	if (Label!="") SetIndexLabel(Index,Label);
	SetIndexBuffer(Index,ViewAy);
	return(0);
}
//------------------------------------------ Style active Line --------------------------
void SetupChartLineColor(int Index,double& ViewAy[],int Style,int Width,color ColorLine,string Label)
{
	switch(Style)
	{
		case 0 : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width,ColorLine);break;
		case 1 : SetIndexStyle(Index,DRAW_HISTOGRAM,STYLE_SOLID,Width,ColorLine);break;
		case 2 : SetIndexStyle(Index,DRAW_ARROW,STYLE_SOLID,Width,ColorLine);break;
		case 3 : SetIndexStyle(Index,DRAW_ZIGZAG,STYLE_SOLID,Width,ColorLine);break;
		default : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width,ColorLine);break;
	}
	if (Label!="") SetIndexLabel(Index,Label);
	SetIndexBuffer(Index,ViewAy);
	return(0);
}
//------------------------------------------ Style active Line --------------------------
void SetupChartLineArrow(int Index,double& ViewAy[],int Style,int Width,int CodeArrow,string Label)
{
	switch(Style)
	{
		case 0 : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
		case 1 : SetIndexStyle(Index,DRAW_HISTOGRAM,STYLE_SOLID,Width);break;
		case 2 : SetIndexStyle(Index,DRAW_ARROW,STYLE_SOLID,Width);break;
		default : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
	}
	if (Label!="") SetIndexLabel(Index,Label);
	SetIndexArrow(Index,CodeArrow);
	SetIndexBuffer(Index,ViewAy);
	return(0);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void InitChart(double& ayShift[])									// 
{
	if (ArraySize(ayShift)>0) ArrayInitialize(ayShift,EMPTY_VALUE);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 TickGo																		~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
datetime	TickGo;					//     
bool	TicketState;				//    
bool TicketGo(int TickInit)
{
	TicketState=false;
	if (TickInit==0)	TickGo=0;
	else {
		if (TickGo==Time[0]) return(false);
		TickGo=Time[0];
		TicketState=true;
	}
	return(true);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 InitCounter																		~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 int InitCounter(int iPreCount,int iMaxPeriod)
{
	// Rule 1
	//if ((Result==0)||(Result>Bars)) Result=Bars;
	int Result=MaxCounter(iPreCount,iMaxPeriod);
	// Rule 2
	if ((Result+iMaxPeriod)>Bars) Result=Bars-iMaxPeriod;
	// Rule 3
	if (Result<iMaxPeriod) Result=0;
	else Result=Result+iMaxPeriod;
	return(Result);
}
//------------------------------------------ StartCounter --------------------------
bool StartCounter(string WindowName,int iPreCount,int& iCalcCount,int iMaxPeriod)
{
	if ((iPreCount>iCalcCount)||(iPreCount==0)) iCalcCount=InitCounter(iPreCount,iMaxPeriod);
	if (iCalcCount==0) 
	{
		Alert(WindowName+" "+Symbol()+"("+Period()+") - Limited Calculate Period");
		return(false);
	}
	return(true);
	//int iBarCount=IndicatorCounted();
	//if (iBarCount>0) return(true);
	//Print("StartCounter");
	return(false);
}
//------------------------------------------ StartCounter --------------------------
int MaxCounter(int iPreCount,int iMaxPeriod)
{
	int Result=iPreCount;
	// Rule 1
	//if ((Result==0)||(Result>Bars)) Result=Bars;
	if (Result==0) Result=Bars-1;
	Result=MathMax(iMaxPeriod,Result);
	return(Result+iMaxPeriod);
}

